/*____________________________________________________________________________*\
 *

 Copyright (c) 1997 John Roy. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    (http://www.johnroy.com/pi3/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: HTTPCore.h$
 * $Date: Sun Aug 10 06:36:30 1997$
 *
 Description:
\*____________________________________________________________________________*/
/* $SourceTop:$ */

#ifndef HTTPCORE_H_
#define HTTPCORE_H_

#include "Pi3API.h"

/*____________________________________________________________________________*\
 Description: Flags
\*____________________________________________________________________________*/
#define RH_CLIENTREQUEST	(1)
#define RH_RESPONSE			(2)

/* --- debug levels for HTTPCore_logDebug() --- */
#define DBG_LOW				(100)
#define DBG_MED				(50)
#define DBG_HIGH			(1)

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_initServer

 Synopsis:
	int HTTPCore_initServer( PIObject *pObject )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_initServer( PIObject *pObject );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_initClient

 Synopsis:
	int HTTPCore_initClient()

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_initClient();

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_cleanupServer

 Synopsis:
	int HTTPCore_cleanupServer()

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_cleanupServer();

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_cleanupClient

 Synopsis:
	int HTTPCore_cleanupClient()

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_cleanupClient();

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_readHeaders

 Synopsis:
	int HTTPCore_readHeaders( PIIOBuffer *pB, PIDB *pDB, int iFlags )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_readHeaders( PIIOBuffer *pB, PIDB *pDB, int iFlags );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_sendGeneralHeaders

 Synopsis:
	int HTTPCore_sendGeneralHeaders( PIHTTP *pPIHTTP )	

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_sendGeneralHeaders( PIHTTP *pPIHTTP );	

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_sendEntityHeaders

 Synopsis:
	int HTTPCore_sendEntityHeaders( PIHTTP *pPIHTTP, PIDB *pR )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_sendEntityHeaders( PIHTTP *pPIHTTP, PIDB *pR );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_getCachedFile

 Synopsis:
	PIFInfo *HTTPCore_getCachedFile( const char *pPath )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI PIFInfo *HTTPCore_getCachedFile( const char *pPath );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_getServerStamp

 Synopsis:
	const char *HTTPCore_getServerStamp()

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI const char *HTTPCore_getServerStamp();

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_releaseCachedFile

 Synopsis:
	void HTTPCore_releaseCachedFile( PIFInfo *pInfo )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI void HTTPCore_releaseCachedFile( PIFInfo *pInfo );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_loadMIMEFile

 Synopsis:
	int HTTPCore_loadMIMEFile( PIObject *pObject, PIDB *pMimeDB,
	const char *pMimeFile )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_loadMIMEFile( PIObject *pObject, PIDB *pMimeDB,
	const char *pMimeFile );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_getMIMETypeFromExtension

 Synopsis:
	const char *HTTPCore_getMIMETypeFromExtension( const char *pExtension )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI const char *HTTPCore_getMIMETypeFromExtension(
		const char *pExtension );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_relativeToAbsolutePath

 Synopsis:
	int HTTPCore_relativeToAbsolutePath( PIDB *pDB,
        const char *pRelative, Pi3String *pResult )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_relativeToAbsolutePath( PIDB *pDB,
        const char *pRelative, Pi3String *pResult );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_logError

 Synopsis:
	int HTTPCore_logError( PIHTTP *pPIHTTP, const char *pFormat, ... )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_logError( PIHTTP *pPIHTTP, const char *pFormat, ... );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_logDebug

 Synopsis:
	int HTTPCore_logDebug( int iLevel, const char *pFormat, ... )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_logDebug( int iLevel, const char *pFormat, ... );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_executePhase

 Synopsis:
	int HTTPCore_executePhase( PIHTTP *pPIHTTP,
		PIObject *(* nextHandler)(void *), void *pArg)

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_executePhase( PIHTTP *pPIHTTP,
		PIObject *(* nextHandler)(void *), void *pArg);

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_dispatch

 Synopsis:
	int HTTPCore_dispatch( PIHTTP *pPIHTTP, int iStartPhase, int iEndPhase )

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_dispatch( PIHTTP *pPIHTTP, int iStartPhase,
		int iEndPhase );

/*____________________________________________________________________________*\
 *
 Name:
	HTTPCore_debugEnabled

 Synopsis:
	int HTTPCore_debugEnabled()

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int HTTPCore_debugEnabled();

#endif /* HTTPCORE_H_ */

